<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\ChecklistService;

class ChecklistController extends FMCrud{
    protected $ChecklistService;
   
    public function __construct($crudService, $environment, ChecklistService $ChecklistService) {
        parent::__construct($crudService, $environment);
        $this->ChecklistService = $ChecklistService;
    }

    public function getSpecificChecklist(DTO\Request $request, DTO\Response $response){
        $params = $request->getParameters();
        $var = $this->ChecklistService->getSpecificChecklist($params);
        $dtsVal = new DataSet("checklist", $var);
        $response->addDataSet($dtsVal);
    }
}

?>