<?php
namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class DashboardFactory {
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
    }
    // requisição de retorno dos dados do dashboard Limpeza Finalizada
    public function getDadosLimpezaFinalizada() {
        
        $sql = "SELECT CA.NRCHECKLISTAGEND, CA.NRLOCALCLIENTE, CA.NRCHECKLIST, CA.NRFUNCIONARIO, CA.IDSITUACAOAGEND,
                  TO_CHAR(CA.DTHORAAGEND, 'DD/MM HH24:MI') DTHORAAGEND, LC.NMLOCALCLIENTE, LC.NRLOCALCLIENTEPAI AS LOCALPAI,
                  LCP.NMLOCALCLIENTE AS NMLOCALPAI, TO_CHAR(CA.DTULTATU, 'HH24:MI')DTULTATU, GCHK.NRGERENCIAMENTOCHK, GCHK.IDSITUACAOGERCHK
                        FROM FCM_CHECKLISTAGEND CA
                        JOIN FCM_LOCALCLI LC
                        ON LC.NRLOCALCLIENTE = CA.NRLOCALCLIENTE
                        JOIN FCM_LOCALCLI LCP
                        ON LCP.NRLOCALCLIENTE = LC.NRLOCALCLIENTEPAI
                        JOIN FCM_CHECKLIST CHK
                        ON CA.NRCHECKLIST = CHK.NRCHECKLIST
                        JOIN FCM_FUNCIONARIO F
                        ON F.NRFUNCIONARIO = CA.NRFUNCIONARIO
                        JOIN FCM_GERENCIAMENTOCHK GCHK
                        ON GCHK.NRCHECKLISTAGEND = CA.NRCHECKLISTAGEND
                        WHERE CA.IDSITUACAOAGEND = '4'
                        AND GCHK.IDSITUACAOGERCHK = '1'
                        AND TRUNC(SYSDATE) = TRUNC(CA.DTHORAAGEND)";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        return $std->fetchAll();
    }
    
    // requisição de retorno dos dados do dashboard Tarefa Atrasada
    public function getDadosTarefaAtrasada() {
        
        $sql = "SELECT  NRCHECKLISTAGEND, NRLOCALCLIENTE, NRCHECKLIST, NRFUNCIONARIO, IDSITUACAOAGEND, DTHORAAGEND, NMLOCALCLIENTE, LOCALPAI, NMLOCALPAI, HORAS AS DTHORAATRASO
                 FROM ( SELECT CA.NRCHECKLISTAGEND, CA.NRLOCALCLIENTE, CA.NRCHECKLIST, CA.NRFUNCIONARIO, CA.IDSITUACAOAGEND,
                        TO_CHAR(CA.DTHORAAGEND, 'DD/MM HH24:MI') DTHORAAGEND, LC.NMLOCALCLIENTE, LC.NRLOCALCLIENTEPAI AS LOCALPAI,
                        LCP.NMLOCALCLIENTE AS NMLOCALPAI, TRUNC(SYSDATE - CA.DTHORAAGEND) * 24 + TRUNC(((SYSDATE - CA.DTHORAAGEND) - TRUNC (SYSDATE - CA.DTHORAAGEND)) * 24) AS HORAS,
                        TRUNC(((((SYSDATE - CA.DTHORAAGEND) - TRUNC(SYSDATE - CA.DTHORAAGEND)) * 24) - TRUNC(((SYSDATE - CA.DTHORAAGEND) - TRUNC(SYSDATE - CA.DTHORAAGEND)) *24))*60) AS MINUTOS
                              FROM FCM_CHECKLISTAGEND CA
                              JOIN FCM_LOCALCLI LC
                              ON LC.NRLOCALCLIENTE = CA.NRLOCALCLIENTE
                              JOIN FCM_LOCALCLI LCP
                              ON LCP.NRLOCALCLIENTE = LC.NRLOCALCLIENTEPAI
                              JOIN FCM_CHECKLIST CHK
                              ON CA.NRCHECKLIST = CHK.NRCHECKLIST
                              JOIN FCM_FUNCIONARIO F
                              ON F.NRFUNCIONARIO = CA.NRFUNCIONARIO
                              WHERE IDSITUACAOAGEND = '5') TAREFASATRASADAS";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        return $std->fetchAll();
    }
    
    public function getDadosTarefaConcluida() {
        
        $sql = "SELECT CA.NRCHECKLISTAGEND, CA.NRLOCALCLIENTE, CA.NRCHECKLIST, CA.NRFUNCIONARIO, CA.IDSITUACAOAGEND,
                  TO_CHAR(CA.DTHORAAGEND, 'DD/MM HH24:MI') DTHORAAGEND, LC.NMLOCALCLIENTE, LC.NRLOCALCLIENTEPAI AS LOCALPAI,
                  LCP.NMLOCALCLIENTE AS NMLOCALPAI, TO_CHAR(CA.DTULTATU, 'HH24:MI')DTULTATU, GCHK.NRGERENCIAMENTOCHK, GCHK.IDSITUACAOGERCHK
                        FROM FCM_CHECKLISTAGEND CA
                        JOIN FCM_LOCALCLI LC
                        ON LC.NRLOCALCLIENTE = CA.NRLOCALCLIENTE
                        JOIN FCM_LOCALCLI LCP
                        ON LCP.NRLOCALCLIENTE = LC.NRLOCALCLIENTEPAI
                        JOIN FCM_CHECKLIST CHK
                        ON CA.NRCHECKLIST = CHK.NRCHECKLIST
                        JOIN FCM_FUNCIONARIO F
                        ON F.NRFUNCIONARIO = CA.NRFUNCIONARIO
                        JOIN FCM_GERENCIAMENTOCHK GCHK
                        ON GCHK.NRCHECKLISTAGEND = CA.NRCHECKLISTAGEND
                        WHERE CA.IDSITUACAOAGEND = '4'
                        AND GCHK.IDSITUACAOGERCHK = '3'
                        AND TRUNC(SYSDATE) = TRUNC(CA.DTHORAAGEND)";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        return $std->fetchAll();
    }
    
    public function countTarefasConcluidas() {
      $sql = "SELECT COUNT(CA.NRCHECKLISTAGEND) AS QTDTAREFASCONCLUIDAS
                  FROM FCM_CHECKLISTAGEND CA
                  JOIN FCM_LOCALCLI LC
                  ON LC.NRLOCALCLIENTE = CA.NRLOCALCLIENTE
                  JOIN FCM_LOCALCLI LCP
                  ON LCP.NRLOCALCLIENTE = LC.NRLOCALCLIENTEPAI
                  JOIN FCM_CHECKLIST CHK
                  ON CA.NRCHECKLIST = CHK.NRCHECKLIST
                  JOIN FCM_FUNCIONARIO F
                  ON F.NRFUNCIONARIO = CA.NRFUNCIONARIO
                  JOIN FCM_GERENCIAMENTOCHK GCHK
                  ON GCHK.NRCHECKLISTAGEND = CA.NRCHECKLISTAGEND
                  WHERE CA.IDSITUACAOAGEND = '4'
                  AND GCHK.IDSITUACAOGERCHK = '3'
                  AND TRUNC(SYSDATE) = TRUNC(CA.DTHORAAGEND)";
      
      $std = $this->connection->prepare($sql);
        
      $std->execute();
      return $std->fetchAll();
    }
    
    public function countTarefas() {
      $sql = "SELECT COUNT(CA.NRCHECKLISTAGEND) AS QTDTAREFAS
                  FROM FCM_CHECKLISTAGEND CA
                  JOIN FCM_LOCALCLI LC
                  ON LC.NRLOCALCLIENTE = CA.NRLOCALCLIENTE
                  JOIN FCM_LOCALCLI LCP
                  ON LCP.NRLOCALCLIENTE = LC.NRLOCALCLIENTEPAI
                  JOIN FCM_CHECKLIST CHK
                  ON CA.NRCHECKLIST = CHK.NRCHECKLIST
                  JOIN FCM_FUNCIONARIO F
                  ON F.NRFUNCIONARIO = CA.NRFUNCIONARIO
                  WHERE TRUNC(SYSDATE) = TRUNC(DTHORAAGEND)";
      
      $std = $this->connection->prepare($sql);
        
      $std->execute();
      return $std->fetchAll();
    }
    
    // requisição para retorno dos dados para o card (Ultimas Tarefas Realizadas) Dashboard Supervisor
    public function getDadosUltimasTarefas($param) {
      
      $sql = "SELECT ULTTAR.CODIGO, ULTTAR.NRLOCALCLIENTE, ULTTAR.NRCHECKLIST, ULTTAR.NRFUNCIONARIO, TO_CHAR(ULTTAR.DTULTATU, 'DD/MM HH24:MI') DTULTATU, ULTTAR.NOME, ULTTAR.SITUACAO, ULTTAR.TIPO, FUNC.NMFUNCIONARIO, LC.NMLOCALCLIENTE, LC.NRLOCALCLIENTEPAI AS LOCALPAI, LCP.NMLOCALCLIENTE AS NMLOCALPAI,
                      ULTTAR.IDSITUACAOGERCHK as STATUS
                      FROM (SELECT NRGERENCIAMENTOCHK AS CODIGO, NRLOCALCLIENTE, NRCHECKLIST, 
                                   NRFUNCIONARIO, DTULTATU, 'Vistoria: '||NMGERENCIAMENTOCHK AS NOME , IDSITUACAOGERCHK AS SITUACAO,
                                   'V' AS TIPO,
                                   CASE IDSITUACAOGERCHK WHEN '1' THEN 'Aguardando vistoria'
                                         WHEN '2' THEN 'Vistoria em andamento'
                                         WHEN '3' THEN 'Tarefa Vistoriada'
                                         ELSE NULL END AS IDSITUACAOGERCHK
                              FROM FCM_GERENCIAMENTOCHK
                              WHERE IDSITUACAOGERCHK = '3'
                          
                             UNION ALL
                          
                             SELECT NRCHECKLISTAGEND AS CODIGO, NRLOCALCLIENTE, NRCHECKLIST, 
                                    NRFUNCIONARIO, DTULTATU, NMCHECKLISTAGEND AS NOME , IDSITUACAOAGEND AS SITUACAO,
                                    'T' AS TIPO,
                                    CASE IDSITUACAOAGEND WHEN '1' THEN 'Pendente'
                                        WHEN '2' THEN 'Tarefa em andamento'
                                        WHEN '3' THEN 'Tarefa Cancelada'
                                        WHEN '4' THEN 'Tarefa Concluída'
                                        WHEN '5' THEN 'Tarefa Atrasada'
                                        ELSE NULL END AS IDSITUACAOAGEND
                               FROM FCM_CHECKLISTAGEND
                               WHERE IDSITUACAOAGEND = '4'
                              ) ULTTAR
                      JOIN FCM_FUNCIONARIO FUNC
                      ON ULTTAR.NRFUNCIONARIO = FUNC.NRFUNCIONARIO
                      JOIN FCM_LOCALCLI LC 
                      ON LC.NRLOCALCLIENTE = ULTTAR.NRLOCALCLIENTE
                      JOIN FCM_LOCALCLI LCP
                      ON LCP.NRLOCALCLIENTE = LC.NRLOCALCLIENTEPAI ".$param."
                      ORDER BY DTULTATU DESC";
      $std = $this->connection->prepare($sql);
        
      $std->execute();
      return $std->fetchAll();
    }
    
   // requisição para retorno dos dados para o card (Resumo de Tarefas) Dashboard Supervisor(Tarefas Diárias)
    public function getDadosResumoTarefas($param) {
      $sql = "SELECT ULTTAR.CODIGO,
                    TO_CHAR(
                      ULTTAR.DTULTATU, 'DD/MM/YYYY'
                    ) DTULTATU,
                    TO_CHAR(
                      ULTTAR.DTULTATU, 'HH24:MI'
                    ) HORA,
                    ULTTAR.NOME, 
                    LC.NMLOCALCLIENTE, 
                    LC.NRLOCALCLIENTEPAI AS LOCALPAI, 
                    LCP.NMLOCALCLIENTE AS NMLOCALPAI, 
                    ULTTAR.IDSITUACAOGERCHK as STATUS,
                    ULTTAR.DIAS
                  FROM 
                    (
                      SELECT 
                        NRGERENCIAMENTOCHK AS CODIGO, 
                        NRLOCALCLIENTE, 
                        NRCHECKLIST, 
                        NRFUNCIONARIO, 
                        DTULTATU, 
                        'Vistoria: ' || NMGERENCIAMENTOCHK AS NOME, 
                        IDSITUACAOGERCHK AS SITUACAO, 
                        'V' AS TIPO, 
                        CASE IDSITUACAOGERCHK 
                          WHEN '1' THEN 'Aguardando vistoria' 
                          WHEN '2' THEN 'Vistoria em andamento' 
                          WHEN '3' THEN 'Vistoria Realizada' 
                          ELSE NULL END AS IDSITUACAOGERCHK,
                          TRUNC(SYSDATE - DTULTATU) AS DIAS
                      FROM 
                        FCM_GERENCIAMENTOCHK 
                      WHERE 
                        (
                          (DTHORAAGEND = SYSDATE) 
                          OR (
                            (DTHORAAGEND < SYSDATE) 
                            
                          )
                        ) 
                      UNION ALL 
                      SELECT 
                        NRCHECKLISTAGEND AS CODIGO, 
                        NRLOCALCLIENTE, 
                        NRCHECKLIST, 
                        NRFUNCIONARIO, 
                        DTULTATU, 
                        NMCHECKLISTAGEND AS NOME, 
                        IDSITUACAOAGEND AS SITUACAO, 
                        'T' AS TIPO, 
                        CASE IDSITUACAOAGEND 
                          WHEN '1' THEN 'Tarefa Pendente' 
                          WHEN '2' THEN 'Tarefa em andamento' 
                          WHEN '3' THEN 'Tarefa Cancelada' 
                          WHEN '4' THEN 'Tarefa Concluída' 
                          WHEN '5' THEN 'Tarefa Atrasada' 
                          ELSE NULL END AS IDSITUACAOAGEND,
                          TRUNC(SYSDATE - DTULTATU) AS DIAS
                      FROM 
                        FCM_CHECKLISTAGEND 
                      WHERE 
                        (
                          (DTHORAAGEND = SYSDATE) 
                          OR (
                            (DTHORAAGEND < SYSDATE) 
                            
                          )
                        )
                    ) ULTTAR 
                    JOIN FCM_FUNCIONARIO FUNC ON ULTTAR.NRFUNCIONARIO = FUNC.NRFUNCIONARIO 
                    JOIN FCM_LOCALCLI LC ON LC.NRLOCALCLIENTE = ULTTAR.NRLOCALCLIENTE 
                    JOIN FCM_LOCALCLI LCP ON LCP.NRLOCALCLIENTE = LC.NRLOCALCLIENTEPAI".$param."
                  ORDER BY 
                    DTULTATU DESC
                  ";
      $std = $this->connection->prepare($sql);
        
      $std->execute();
      return $std->fetchAll();
    }
    
    // requisição para retorno dos dados do grafico Tarefas Realizadas Dashboard Supervisor
    public function getDadosChartTarefas() {
        
        $sql = "SELECT TC.NMTIPOLOCALCLI, COUNT(CA.NRCHECKLISTAGEND) AS QUANTIDADE
                  FROM FCM_CHECKLISTAGEND CA
                  JOIN FCM_LOCALCLI LC
                  ON LC.NRLOCALCLIENTE = CA.NRLOCALCLIENTE
                  JOIN FCM_TIPOLOCALCLI TC
                  ON TC.NRTIPOLOCALCLI = LC.NRTIPOLOCALCLI
                  WHERE TRUNC(SYSDATE) = TRUNC(DTHORAAGEND)
                  AND IDSITUACAOAGEND = '4'
                  AND TC.IDTIPOLOCALCLI = '3'
                  GROUP BY TC.NMTIPOLOCALCLI";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        return $std->fetchAll();
    }
    
     // requisição para retorno dos dados para o grafico Não Conformidades Dashboard Supervisor
    public function getDadosChartNaoConformidades() {
        
        $sql = "SELECT TC.NMTIPOLOCALCLI, COUNT(C.NRCRITERIOTARGERCHK) AS QUANTIDADE
                  FROM FCM_CRITERIOTARGERCHK C
                  JOIN FCM_TAREFAGERCHK TG
                  ON TG.NRTAREFAGERCHK = C.NRTAREFAGERCHK
                  JOIN FCM_GERENCIAMENTOCHK GCHK
                  ON GCHK.NRGERENCIAMENTOCHK = TG.NRGERENCIAMENTOCHK
                  JOIN FCM_LOCALCLI LC
                  ON LC.NRLOCALCLIENTE = GCHK.NRLOCALCLIENTE
                  JOIN FCM_TIPOLOCALCLI TC
                  ON TC.NRTIPOLOCALCLI = LC.NRTIPOLOCALCLI
                  WHERE IDMARCADO = 'S'
                  AND TC.IDTIPOLOCALCLI = '3'
                  AND TRUNC(SYSDATE) = TRUNC(DTHORAAGEND)
                  GROUP BY TC.NMTIPOLOCALCLI
                  ORDER BY QUANTIDADE ASC";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        return $std->fetchAll();
    }
    
   // requisição para retorno dos dados para grafico Progresso Diario Dashboard Supervisor(Tarefas Diárias)
    public function countTarefasConcluidasDia() {
        
        $sql = "SELECT
                  QUANTIDADE_CONCLUIDAS.NMLOCALCLIENTE,
                  QUANTIDADE_CONCLUIDAS.QUANTIDADE,
                  (QUANTIDADE_CONCLUIDAS.QUANTIDADE * 100 / QUANTIDADE_TOTAL.QUANTIDADE_TOTAL )AS Porcentagem
                
                FROM (SELECT
                       LC.NMLOCALCLIENTE,
                       CA.NRLOCALCLIENTE,
                       COUNT(CA.NRCHECKLISTAGEND) AS QUANTIDADE
                     FROM FCM_CHECKLISTAGEND CA
                     JOIN FCM_LOCALCLI LC
                       ON LC.NRLOCALCLIENTE = CA.NRLOCALCLIENTE
                     JOIN FCM_TIPOLOCALCLI TC
                       ON TC.NRTIPOLOCALCLI = LC.NRTIPOLOCALCLI
                     WHERE TRUNC(SYSDATE) = TRUNC(DTHORAAGEND)
                     AND TC.IDTIPOLOCALCLI = '3'
                     AND CA.IDSITUACAOAGEND = '4'
                     GROUP BY LC.NMLOCALCLIENTE,
                              CA.NRLOCALCLIENTE) QUANTIDADE_CONCLUIDAS,
                     (SELECT
                       LC.NMLOCALCLIENTE,
                       CA.NRLOCALCLIENTE,
                       COUNT(CA.NRCHECKLISTAGEND) AS QUANTIDADE_TOTAL
                     FROM FCM_CHECKLISTAGEND CA
                     JOIN FCM_LOCALCLI LC
                       ON LC.NRLOCALCLIENTE = CA.NRLOCALCLIENTE
                     JOIN FCM_TIPOLOCALCLI TC
                       ON TC.NRTIPOLOCALCLI = LC.NRTIPOLOCALCLI
                     WHERE TRUNC(SYSDATE) = TRUNC(DTHORAAGEND)
                     AND TC.IDTIPOLOCALCLI = '3'
                     GROUP BY LC.NMLOCALCLIENTE,
                              CA.NRLOCALCLIENTE) QUANTIDADE_TOTAL
                WHERE QUANTIDADE_TOTAL.NRLOCALCLIENTE = QUANTIDADE_CONCLUIDAS.NRLOCALCLIENTE";
                        
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        return $std->fetchAll();
    }

    
}