/* eslint-disable no-console */
import { ComponentRender, IComponentEvents } from '@zeedhi/common';
import { IEventParam } from '@zeedhi/core';
import { IColorPicker } from './IColorPicker';

export class ColorPickerClass extends ComponentRender implements IColorPicker {
  public events!: IComponentEvents<IEventParam<any>>;

  public disabled: boolean = false;

  public value!: string | Object;

  constructor(props: IColorPicker) {
    super(props);
    this.disabled = this.getInitValue('disabled', props.disabled, this.disabled);
    this.value = this.getInitValue('value', props.value, this.value);
    this.createAccessors();
  }

  public inputColor() {
    if (this.events.inputColor) {
      this.events.inputColor({ component: this });
    }
  }

  public updateColor() {
    if (this.events.updateColor) {
      this.events.updateColor({ component: this });
    }
  }
}
