/* eslint-disable */
import {
  IDictionary, Metadata,
  Http, IEventParam, Loader, Router,
} from '@zeedhi/core';
import {
  Container, CollapseCard, Col, Card, Row,
  TextInput, IComponentRender, Button,
} from '@zeedhi/common';
import { getRouteParams, VUE_APP_BASE_URL } from '../router';

export class AgSimplesController {
  public isVisibleElement: boolean = !(localStorage.getItem('idpermissslocais') === 'V');
  
  public infoList: IDictionary = {
    localType: [],
    quantity: [],
    title: [],
  };
  
  public dataFilter: IDictionary = {
    inputLocal: '',
  };

  public test = Loader.getInstance('GerenciarLocaisController');

  public title: string = '';

  // Gera o header do collapse card
public mainCard(idCard: number, titleCard: string, iconName: string) {
    const newComponent = {
      name: `${titleCard}${idCard}`,
      component: 'ZdCollapseCard',
      isVisible: true,
      cssClass: 'zd-mb-4',
      header: [
        {
          name: '',
          component: 'ZdRow',
          children: [
            {
              name: '',
              component: 'ZdText',
              cssClass: 'zd-mr-2',
              text: iconName,
              tag: 'v-icon',
            },
            {
              name: 'cardText',
              component: 'ZdText',
              cssClass: 'zd-mt-1',
              text: titleCard,
              tag: 'h3',
              style: {
                color: '#2196f3',
              },
            },
          ],
        },
      ],
      children: [],
    };
    return newComponent;
  }

  // Gera os Children do collapse card
  public childMainCard(idChild: string, textCard: string, sourceLink: string): IDictionary {
    return {
      name: `card${idChild}`,
      component: 'ZdCard',
      elevation: 2,
      cssClass: 'zd-mb-2',
      hover: true,
      children: [
        {
          name: 'rowTest',
          component: 'ZdRow',
          children: [
            {
              name: 'col4',
              component: 'ZdCol',
              sm: 3,
              children: [
                {
                  name: 'texttest',
                  component: 'ZdText',
                  text: textCard,
                },
              ],
            },
            {
              name: `col2_${textCard}`,
              component: 'ZdCol',
              align: 'center',
              sm: 7,
              children: [
                {
                  name: `expandedCollapse_${textCard}`,
                  component: 'ZdImage',
                  isVisible: false,
                  src: sourceLink,
                  width: '256px',
                  height: '256px',
                  cssClass: 'zd-mx-auto',
                  events: {
                    onCreated: '{{QRCodeController.generateQRCode}}',
                  },
                },
              ],
            },
            {
              name: 'col3',
              component: 'ZdCol',
              sm: 2,
              cssClass: 'text-end',
              children: [
                {
                  name: 'buttontest2',
                  component: 'ZdButton',
                  iconName: 'mdi-qrcode',
                  icon: true,
                  small: true,
                  events: {
                    click: '{{QRCodeController.collapseQrCode}}',
                  },
                },
                {
                  name: 'buttontest',
                  component: 'ZdButton',
                  iconName: 'mdi-pencil',
                  to: `/localAtendimento/${idChild}`,
                  icon: true,
                  small: true,
                  isVisible: this.isVisibleElement,
                },
              ],
            },
            {
              name: "teste",
              component: "ZdRow",
              isVisible: false,
              children: [
                {
                  name: 'col5',
                  component: 'ZdCol',
                  align:'right',
                  cols: 12,
                  children: [
                    {
                      name: `buttontest3_${textCard}`,
                      component: 'ZdButton',
                      iconName: 'mdi-printer',
                      icon: true,
                      small: true,
                      events: {
                    	click: '{{QRCodeController.printQrCode}}',
                      },
                    },
                  ],
                },
              ],
            },
          ],
        },
      ],
    };
  }

  public separator(): IDictionary {
    return {
      name: 'basicUsageDivider',
      component: 'ZdDivider',
    };
  }

  // Protótipo do titulo da página
  public textTitle(nmTitle: string, nrId: number): any {
    return {
      name: `title${nrId}`,
      component: 'ZdText',
      text: `${nmTitle}`,
      tag: 'h1',
      style: {
        color: '#2196f3',
      },
    };
  }

  public inicializarDados() {
    // this.setLocal();
  }

  public setDados(nome: string, code:number) {
    return {
      name: nome,
      value: code,
    };
  }

  // Requisição buscando nome e id dos tipos de locais e Adiciona o collapse ao Container
  // public setNewAgSimples() {
  //   const selectObject = Metadata.getInstance<Container>('mainContainer');
  //   Http.get('/getAgSimples').then((response: IDictionary) => {
  //     response.data.dataset.options.forEach((dados: IDictionary) => {
  //       selectObject.children.push(this.agCompletoCard(dados.NMTIPOLOCALCLI, dados.NRTIPOLOCALCLI));
  //     });
  //   });
  // }

  public setLocal({ component } : {component: Container}) {
    const routeParams = getRouteParams();
    const { bloco } = routeParams;

    // const keyBind = { Banheiro: { iconName: 'mdi-toilet' }, Jardim: { iconName: 'mdi-toilet' }, Salões: { iconName: 'mdi-toilet' } };
    // ToDo: hard coded config
    const baseLink = VUE_APP_BASE_URL;

    Http.get(`/Local/${bloco}/children`).then((response: IDictionary) => {
      const filteredChildren:IDictionary = { };
      response.data.dataset.Locals.map((child: IDictionary) => {
        const { NMTIPOLOCALCLI } = child;
        if (!filteredChildren[NMTIPOLOCALCLI]) {
          filteredChildren[NMTIPOLOCALCLI] = [];
        }
        filteredChildren[NMTIPOLOCALCLI].push(child);
        return child;
      });
      Object.keys(filteredChildren).map((key, indexK) => {
        const card: any = this.mainCard(indexK + 1, `${key} | ${filteredChildren[key].length}`, '');
        filteredChildren[key].map((child: IDictionary) => {
          const sourceLink = `${baseLink}/${child.NRLOCALCLIENTE}`;
          const childCard = this.childMainCard(child.NRLOCALCLIENTE, child.NMLOCALCLIENTE, sourceLink);
          //const sep= this.separator();
          card.children.push(childCard);
          //card.children.push(sep);
          return childCard;
        });
        component.addChild(card);
        return card;
      });
      // response.data.dataset.options.forEach((dados: IDictionary) => {
      //   component.children.push(this.agCompletoCard(dados.NMTIPOLOCALCLI, dados.NRTIPOLOCALCLI, dados.CONT));
      // });
    });
  }

  public filteredLocal({ component }: IEventParam<TextInput>) {
    const containerObject = Metadata.getInstance<Container>('mainContainer');
    const searchObject = component.value.toLowerCase();
    containerObject.children.map((child) =>{
      if(child.component === 'ZdCollapseCard'){
        const titleCompare = child.name.split(' ')[0];
        const lowerTitleCompare = titleCompare.toLowerCase();
        if(lowerTitleCompare.includes(searchObject)) {
          child.isVisible = true;
        } else {
          child.isVisible = false;
        }
     }
    });
  }

  // Quando expandir o collapase, deverá ser renderizado, as infos necessárias dos children
  // public setChildrenLocal({ component }: IEventParam<CollapseCard>) {
  //   const params = {
  //     NRLOCALCLIENTEPAI: component.name,
  //   };
  //   Http.post('/getRowCard', { params }).then((response: IDictionary) => {
  //     response.data.dataset.options.forEach((dados: IDictionary) => {
  //       component.addChild(this.agChildrenLocal(dados.NMLOCALCLIENTE, dados.NRLOCALCLIENTE));
  //     });
  //   });
  // }

  // Recebe a requisição da tela gLocais com o id do local, requisita do banco os dados desse local muda de pagina e cria o titulo referente ao AgSimples
  public async setTitle() {
    const routeParams = getRouteParams();
    const { bloco } = routeParams;
    const params = {
      NRLOCALCLIENTE: bloco,
    };
    Http.post('/geraAgSimplesPage', { params }).then((response: IDictionary) => {
      response.data.dataset.options.forEach((dados: IDictionary) => {
        Metadata.getInstance<Row>('rowTitle').addChild(this.textTitle(dados.NMLOCALCLIENTE, dados.NRLOCALCLIENTE) as IComponentRender);
      });
    });
  }

  // Altera o nome do botão afim de obter o id daquele agrupamento simples
  public setNewLocalButton({ component }: IEventParam<Button>) {
    const routeParams = getRouteParams();
    const { bloco } = routeParams;

    component.name = `btn${bloco}`;
  }
}
