import { AlertService, Form } from '@zeedhi/common';
import {
  Http, IDictionary, Metadata, Router,
} from '@zeedhi/core';

export class LoginController {
  public logar() {
    if (Metadata.getInstance<Form>('login-form').validate()) {
      Http.post('/validaLogin', Metadata.getInstance<Form>('login-form').value).then((response: IDictionary) => {
        const database = response.data.dataset.func;
        if ((Object.keys(response.data.dataset.func)).length) {
          this.setUser(database.NRFUNCIONARIO, database.TOKEN);
        } else {
          this.loginFail();
        }
      });
    }
  }

  public setUser(nrfuncionario: number, token: string) {
    window.localStorage.setItem('UserLogado', String(nrfuncionario));
    window.localStorage.setItem('Token', token);
    Router.replace('/');
  }

  public loginFail() {
    AlertService.show({
      name: 'basic-alert',
      text: 'Login ou senha invalida!',
      top: true,
      left: false,
      timeout: 3000,
      color: 'error',
    });
  }

  public delet() {
    window.localStorage.clear();
    Router.replace('/Login');
  }
}
